"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var React = __importStar(require("react"));
var DayPickerInput_1 = __importDefault(require("react-day-picker/DayPickerInput"));
var isString_1 = __importDefault(require("lodash-es/isString"));
var upperFirst_1 = __importDefault(require("lodash-es/upperFirst"));
var Icon_1 = __importDefault(require("@steroidsjs/core/ui/icon/Icon"));
var DropDownField_1 = __importDefault(require("@steroidsjs/core/ui/form/DropDownField"));
var hooks_1 = require("@steroidsjs/core/hooks");
var react_1 = require("react");
function YearMonthForm(props) {
    var localeUtils = props.localeUtils, locale = props.locale, fromMonth = props.fromMonth, toMonth = props.toMonth, classNames = props.classNames, customClassNames = props.customClassNames, date = props.date;
    var month = date.getMonth();
    var year = date.getFullYear();
    var handleYearChange = react_1.useCallback(function (year) {
        props.onChange(new Date(year, month));
    }, [props.onChange, month]);
    var handleMonthChange = react_1.useCallback(function (month) {
        props.onChange(new Date(year, month));
    }, [props.onChange, year]);
    var months = react_1.useMemo(function () { return (localeUtils.getMonths(locale).map(function (item, index) { return ({
        id: index,
        label: upperFirst_1["default"](item)
    }); })); }, [localeUtils, locale]);
    var years = react_1.useMemo(function () {
        var result = [];
        for (var i = fromMonth.getFullYear(); i <= toMonth.getFullYear(); i += 1) {
            result.push(i);
        }
        return result;
    }, [fromMonth, toMonth]);
    return (React.createElement("div", { className: classNames.caption },
        React.createElement("div", { className: customClassNames.caption },
            React.createElement("div", { className: customClassNames.yearSelect },
                React.createElement(DropDownField_1["default"], { attribute: 'month', size: 'md', layout: false, noBorder: true, items: months, input: { onChange: handleMonthChange }, selectedIds: [month] })),
            React.createElement("div", { className: customClassNames.monthSelect },
                React.createElement(DropDownField_1["default"], { attribute: 'year', size: 'md', layout: false, className: customClassNames.monthSelect, noBorder: true, items: years, input: { onChange: handleYearChange }, selectedIds: [year] })))));
}
function DateFieldView(props) {
    var bem = hooks_1.useBem('DateFieldView');
    var captionElement = react_1.useCallback(function (_a) {
        var date = _a.date, localeUtils = _a.localeUtils, classNames = _a.classNames, locale = _a.locale;
        return (React.createElement(YearMonthForm, { date: date, localeUtils: localeUtils, locale: locale, classNames: classNames, customClassNames: {
                caption: bem.element('caption'),
                yearSelect: bem.element('caption-year'),
                monthSelect: bem.element('caption-month')
            }, onChange: props.pickerProps.onYearMonthChange, fromMonth: props.pickerProps.dayPickerProps.fromMonth, toMonth: props.pickerProps.dayPickerProps.toMonth }));
    }, [
        props.pickerProps.onYearMonthChange,
        props.pickerProps.dayPickerProps.fromMonth,
        props.pickerProps.dayPickerProps.toMonth
    ]);
    return (React.createElement("div", null,
        React.createElement(DayPickerInput_1["default"], __assign({}, props.pickerProps, { name: props.input.name, placeholder: props.placeholder || props.displayFormat, value: props.parseDate(props.input.value), parseDate: props.parseDate, formatDate: props.formatDate, onDayChange: function (value) { return props.onChange(value); }, dayPickerProps: __assign({ captionElement: captionElement, locale: props.locale.language, localeUtils: props.localeUtils }, props.pickerProps.dayPickerProps), inputProps: __assign(__assign({}, (props.pickerProps && props.pickerProps.inputProps)), { className: bem(bem.element('input'), 'form-control', 'form-control-' + props.size, props.isInvalid && 'is-invalid'), disabled: props.disabled, required: props.required }), component: React.forwardRef(function (inputProps, ref) { return (React.createElement("div", { ref: ref, className: bem(bem.block({
                    size: props.size,
                    'has-icon': !!props.icon,
                    'is-invalid': !!props.isInvalid
                }), props.className, inputProps.className) },
                React.createElement("input", __assign({}, inputProps)),
                props.icon && (React.createElement(Icon_1["default"], { className: bem.element('icon', {
                        "default": !isString_1["default"](props.icon)
                    }), name: isString_1["default"](props.icon) ? props.icon : 'calendar-alt' })))); }) }))));
}
exports["default"] = DateFieldView;
